Unit aeg1e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AA02Z_p, UTAE10_p;

procedure aeg1e(N :Integer; var A :Array of Extended;
                var EVR :Array of Extended; var EVI :Array of Extended;
                var V :Array of Extended; var IRAB1 :Array of Integer;
                var IERR :Integer);

implementation

procedure aeg1e(N :Integer; var A :Array of Extended;
                var EVR :Array of Extended; var EVI :Array of Extended;
                var V :Array of Extended; var IRAB1 :Array of Integer;
                var IERR :Integer);
var
IR1,IR2,B,C,D,E,F,G,H,K,L,M,O,P,Q,R,S,T,U,W,X,Y,Z,BA,BB,BC,BD,BE,BF,
   BG :Integer;
I,J,BH,BI,BJ,BK,BL,BM,BN,BO,BP,BQ,BR,BS,BT,BU :Extended;
BX :Complex;
BW :Boolean;
const
SYS051 :Extended = 1.1107652e-16;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35,_36,
_37,_38,_39,_40,_41,_42,_43,_44,_45,_46,_47,_48,_49,_50,_51,_52,_53,
_54,_55,_56,_57,_58,_59,_60,_61,_62,_63,_64,_65,_66;
begin
IR1 := 1;
IR2 := N;
E := IR2-1;
F := IR1+1;
if ( E < F ) 
 then goto _9;
for D:=F to E do
 begin
  G := D-1;
  I := 0.e0;
  B := D;
  for C:=D to IR2 do
   begin
    if ( Abs(A[(C-1)+(G-1)*N]) <= Abs(I) ) 
     then goto _1;
    I := A[(C-1)+(G-1)*N];
    B := C;
_1:
   end;
  IRAB1[D-1] := B;
  if ( B = D ) 
   then goto _4;
  for C:=G to N do
   begin
    J := A[(B-1)+(C-1)*N];
    A[(B-1)+(C-1)*N] := A[(D-1)+(C-1)*N];
    A[(D-1)+(C-1)*N] := J;
_2:
   end;
  for C:=1 to IR2 do
   begin
    J := A[(C-1)+(B-1)*N];
    A[(C-1)+(B-1)*N] := A[(C-1)+(D-1)*N];
    A[(C-1)+(D-1)*N] := J;
_3:
   end;
_4:
  if ( I = 0.e0 ) 
   then goto _8;
  H := D+1;
  for B:=H to IR2 do
   begin
    J := A[(B-1)+(G-1)*N];
    if ( J = 0.e0 ) 
     then goto _7;
    J := J/I;
    A[(B-1)+(G-1)*N] := J;
    for C:=D to N do
     begin
_5:
      A[(B-1)+(C-1)*N] := A[(B-1)+(C-1)*N]-J*A[(D-1)+(C-1)*N];
     end;
    for C:=1 to IR2 do
     begin
_6:
      A[(C-1)+(D-1)*N] := A[(C-1)+(D-1)*N]+J*A[(C-1)+(B-1)*N];
     end;
_7:
   end;
_8:
 end;
_9:
for K:=1 to N do
 begin
  for L:=1 to N do
   begin
_10:
    V[(K-1)+(L-1)*N] := 0.e0;
   end;
  V[(K-1)+(K-1)*N] := 1.e0;
_11:
 end;
M := IR2-IR1-1;
if ( M < 1 ) 
 then goto _15;
for O:=1 to M do
 begin
  P := IR2-O;
  Q := P+1;
  for K:=Q to IR2 do
   begin
_12:
    V[(K-1)+(P-1)*N] := A[(K-1)+(P-2)*N];
   end;
  K := IRAB1[P-1];
  if ( K = P ) 
   then goto _14;
  for L:=P to IR2 do
   begin
    V[(P-1)+(L-1)*N] := V[(K-1)+(L-1)*N];
    V[(K-1)+(L-1)*N] := 0.e0;
_13:
   end;
  V[(K-1)+(P-1)*N] := 1.e0;
_14:
 end;
_15:
IERR := 0;
BU := 0.0e0;
T := 1;
for R:=1 to N do
 begin
  for S:=T to N do
   begin
_16:
    BU := BU+Abs(A[(R-1)+(S-1)*N]);
   end;
  T := R;
  if ( R >= IR1 ) and ( R <= IR2 ) 
   then goto _17;
  EVR[R-1] := A[(R-1)+(R-1)*N];
  EVI[R-1] := 0.0e0;
_17:
 end;
X := IR2;
BL := 0.0e0;
_18:
if ( X < IR1 ) 
 then goto _44;
BE := 0;
BC := X-1;
BG := BC-1;
_19:
for BA:=IR1 to X do
 begin
  U := X+IR1-BA;
  if ( U = IR1 ) 
   then goto _21;
  BK := Abs(A[(U-2)+(U-2)*N])+Abs(A[(U-1)+(U-1)*N]);
  if ( BK = 0.0e0 ) 
   then BK := BU;
  if ( Abs(A[(U-1)+(U-2)*N]) <= SYS051*BK ) 
   then goto _21;
_20:
 end;
_21:
BN := A[(X-1)+(X-1)*N];
if ( U = X ) 
 then goto _37;
BO := A[(BC-1)+(BC-1)*N];
BM := A[(X-1)+(BC-1)*N]*A[(BC-1)+(X-1)*N];
if ( U = BC ) 
 then goto _38;
if ( BE = 30 ) 
 then goto _65;
if ( BE <> 10 ) and ( BE <> 20 ) 
 then goto _23;
BL := BL+BN;
for R:=IR1 to X do
 begin
_22:
  A[(R-1)+(R-1)*N] := A[(R-1)+(R-1)*N]-BN;
 end;
BK := Abs(A[(X-1)+(BC-1)*N])+Abs(A[(BC-1)+(BG-1)*N]);
BN := 0.75e0*BK;
BO := BN;
BM := -0.4375e0*BK*BK;
_23:
BE := BE+1;
for BB:=U to BG do
 begin
  W := BG+U-BB;
  BT := A[(W-1)+(W-1)*N];
  BJ := BN-BT;
  BK := BO-BT;
  BH := (BJ*BK-BM)/A[(W+0)+(W-1)*N]+A[(W-1)+(W+0)*N];
  BI := A[(W+0)+(W+0)*N]-BT-BJ-BK;
  BJ := A[(W+1)+(W+0)*N];
  BK := Abs(BH)+Abs(BI)+Abs(BJ);
  BH := BH/BK;
  BI := BI/BK;
  BJ := BJ/BK;
  if ( W = U ) 
   then goto _25;
  if ( Abs(A[(W-1)+(W-2)*N])*(Abs(BI)+Abs(BJ)) <= SYS051*
       Abs(BH)*(Abs(A[(W-2)+(W-2)*N])+Abs(BT)+Abs(A[(W+0)+(W+0)*N])) )
   then goto _25;
_24:
 end;
_25:
BF := W+2;
for R:=BF to X do
 begin
  A[(R-1)+(R-3)*N] := 0.0e0;
  if ( R = BF ) 
   then goto _26;
  A[(R-1)+(R-4)*N] := 0.0e0;
_26:
 end;
for T:=W to BC do
 begin
  BW := ( T <> BC );
  if ( T = W ) 
   then goto _27;
  BH := A[(T-1)+(T-2)*N];
  BI := A[(T+0)+(T-2)*N];
  BJ := 0.0e0;
  if ( BW ) 
   then BJ := A[(T+1)+(T-2)*N];
  BN := Abs(BH)+Abs(BI)+Abs(BJ);
  if ( BN = 0.0e0 ) 
   then goto _36;
  BH := BH/BN;
  BI := BI/BN;
  BJ := BJ/BN;
_27:
  BK := Sign(Sqrt(BH*BH+BI*BI+BJ*BJ),BH);
  if ( T = W ) 
   then goto _28;
  A[(T-1)+(T-2)*N] := -BK*BN;
  goto _29;
_28:
  if ( U <> W ) 
   then A[(T-1)+(T-2)*N] := -A[(T-1)+(T-2)*N];
_29:
  BH := BH+BK;
  BN := BH/BK;
  BO := BI/BK;
  BT := BJ/BK;
  BI := BI/BH;
  BJ := BJ/BH;
  for S:=T to N do
   begin
    BH := A[(T-1)+(S-1)*N]+BI*A[(T+0)+(S-1)*N];
    if ( not BW ) 
     then goto _30;
    BH := BH+BJ*A[(T+1)+(S-1)*N];
    A[(T+1)+(S-1)*N] := A[(T+1)+(S-1)*N]-BH*BT;
_30:
    A[(T+0)+(S-1)*N] := A[(T+0)+(S-1)*N]-BH*BO;
    A[(T-1)+(S-1)*N] := A[(T-1)+(S-1)*N]-BH*BN;
_31:
   end;
  S := Min0(X,T+3);
  for R:=1 to S do
   begin
    BH := BN*A[(R-1)+(T-1)*N]+BO*A[(R-1)+(T+0)*N];
    if ( not BW ) 
     then goto _32;
    BH := BH+BT*A[(R-1)+(T+1)*N];
    A[(R-1)+(T+1)*N] := A[(R-1)+(T+1)*N]-BH*BJ;
_32:
    A[(R-1)+(T+0)*N] := A[(R-1)+(T+0)*N]-BH*BI;
    A[(R-1)+(T-1)*N] := A[(R-1)+(T-1)*N]-BH;
_33:
   end;
  for R:=IR1 to IR2 do
   begin
    BH := BN*V[(R-1)+(T-1)*N]+BO*V[(R-1)+(T+0)*N];
    if ( not BW ) 
     then goto _34;
    BH := BH+BT*V[(R-1)+(T+1)*N];
    V[(R-1)+(T+1)*N] := V[(R-1)+(T+1)*N]-BH*BJ;
_34:
    V[(R-1)+(T+0)*N] := V[(R-1)+(T+0)*N]-BH*BI;
    V[(R-1)+(T-1)*N] := V[(R-1)+(T-1)*N]-BH;
_35:
   end;
_36:
 end;
goto _19;
_37:
A[(X-1)+(X-1)*N] := BN+BL;
EVR[X-1] := A[(X-1)+(X-1)*N];
EVI[X-1] := 0.0e0;
X := BC;
goto _18;
_38:
BH := (BO-BN)/2.0e0;
BI := BH*BH+BM;
BT := Sqrt(Abs(BI));
A[(X-1)+(X-1)*N] := BN+BL;
BN := A[(X-1)+(X-1)*N];
A[(BC-1)+(BC-1)*N] := BO+BL;
if ( BI < 0.0e0 ) 
 then goto _42;
BT := BH+Sign(BT,BH);
EVR[BC-1] := BN+BT;
EVR[X-1] := EVR[BC-1];
if ( BT <> 0.0e0 ) 
 then EVR[X-1] := BN-BM/BT;
EVI[BC-1] := 0.0e0;
EVI[X-1] := 0.0e0;
BN := A[(X-1)+(BC-1)*N];
BK := Abs(BN)+Abs(BT);
BH := BN/BK;
BI := BT/BK;
BJ := Sqrt(BH*BH+BI*BI);
BH := BH/BJ;
BI := BI/BJ;
for S:=BC to N do
 begin
  BT := A[(BC-1)+(S-1)*N];
  A[(BC-1)+(S-1)*N] := BI*BT+BH*A[(X-1)+(S-1)*N];
  A[(X-1)+(S-1)*N] := BI*A[(X-1)+(S-1)*N]-BH*BT;
_39:
 end;
for R:=1 to X do
 begin
  BT := A[(R-1)+(BC-1)*N];
  A[(R-1)+(BC-1)*N] := BI*BT+BH*A[(R-1)+(X-1)*N];
  A[(R-1)+(X-1)*N] := BI*A[(R-1)+(X-1)*N]-BH*BT;
_40:
 end;
for R:=IR1 to IR2 do
 begin
  BT := V[(R-1)+(BC-1)*N];
  V[(R-1)+(BC-1)*N] := BI*BT+BH*V[(R-1)+(X-1)*N];
  V[(R-1)+(X-1)*N] := BI*V[(R-1)+(X-1)*N]-BH*BT;
_41:
 end;
goto _43;
_42:
EVR[BC-1] := BN+BH;
EVR[X-1] := BN+BH;
EVI[BC-1] := BT;
EVI[X-1] := -BT;
_43:
X := BG;
goto _18;
_44:
if ( BU = 0.0e0 ) 
 then goto _66;
for BD:=1 to N do
 begin
  X := N+1-BD;
  BH := EVR[X-1];
  BI := EVI[X-1];
  BC := X-1;
  if ( BI ) < 0
   then goto _52
   else if ( BI ) > 0
         then goto _60
         else goto _45;
_45:
  W := X;
  A[(X-1)+(X-1)*N] := 1.0e0;
  if ( BC = 0 ) 
   then goto _60;
  for Y:=1 to BC do
   begin
    R := X-Y;
    BM := A[(R-1)+(R-1)*N]-BH;
    BJ := A[(R-1)+(X-1)*N];
    if ( W > BC ) 
     then goto _47;
    for S:=W to BC do
     begin
_46:
      BJ := BJ+A[(R-1)+(S-1)*N]*A[(S-1)+(X-1)*N];
     end;
_47:
    if ( EVI[R-1] >= 0.0e0 ) 
     then goto _48;
    BT := BM;
    BK := BJ;
    goto _51;
_48:
    W := R;
    if ( EVI[R-1] <> 0.0e0 ) 
     then goto _49;
    BL := BM;
    if ( BM = 0.0e0 ) 
     then BL := SYS051*BU;
    A[(R-1)+(X-1)*N] := -BJ/BL;
    goto _51;
_49:
    BN := A[(R-1)+(R+0)*N];
    BO := A[(R+0)+(R-1)*N];
    BI := (EVR[R-1]-BH)*(EVR[R-1]-BH)+EVI[R-1]*EVI[R-1];
    BL := (BN*BK-BT*BJ)/BI;
    A[(R-1)+(X-1)*N] := BL;
    if ( Abs(BN) <= Abs(BT) ) 
     then goto _50;
    A[(R+0)+(X-1)*N] := (-BJ-BM*BL)/BN;
    goto _51;
_50:
    A[(R+0)+(X-1)*N] := (-BK-BO*BL)/BT;
_51:
   end;
  goto _60;
_52:
  W := BC;
  if ( Abs(A[(X-1)+(BC-1)*N]) <= Abs(A[(BC-1)+(X-1)*N]) ) 
   then goto _53;
  A[(BC-1)+(BC-1)*N] := BI/A[(X-1)+(BC-1)*N];
  A[(BC-1)+(X-1)*N] := -(A[(X-1)+(X-1)*N]-BH)/A[(X-1)+(BC-1)*N];
  goto _54;
_53:
  AA02Z(0.0e0,-A[(BC-1)+(X-1)*N],A[(BC-1)+(BC-1)*N]-BH,BI,A[(BC-1)+(BC-1)*N],A[(BC-1)+(X-1)*N]);
_54:
  A[(X-1)+(BC-1)*N] := 0.0e0;
  A[(X-1)+(X-1)*N] := 1.0e0;
  BG := BC-1;
  if ( BG = 0 ) 
   then goto _60;
  for Y:=1 to BG do
   begin
    R := BC-Y;
    BM := A[(R-1)+(R-1)*N]-BH;
    BP := 0.0e0;
    BQ := A[(R-1)+(X-1)*N];
    for S:=W to BC do
     begin
      BP := BP+A[(R-1)+(S-1)*N]*A[(S-1)+(BC-1)*N];
      BQ := BQ+A[(R-1)+(S-1)*N]*A[(S-1)+(X-1)*N];
_55:
     end;
    if ( EVI[R-1] >= 0.0e0 ) 
     then goto _56;
    BT := BM;
    BJ := BP;
    BK := BQ;
    goto _59;
_56:
    W := R;
    if ( EVI[R-1] <> 0.0e0 ) 
     then goto _57;
    AA02Z(-BP,-BQ,BM,BI,A[(R-1)+(BC-1)*N],A[(R-1)+(X-1)*N]);
    goto _59;
_57:
    BN := A[(R-1)+(R+0)*N];
    BO := A[(R+0)+(R-1)*N];
    BS := (EVR[R-1]-BH)*(EVR[R-1]-BH)+EVI[R-1]*EVI[R-1]-BI*BI;
    BR := (EVR[R-1]-BH)*2.0e0*BI;
    if ( BS = 0.0e0 ) and ( BR = 0.0e0 ) 
     then BS := SYS051*BU*(Abs(BM)+
Abs(BI)+Abs(BN)+Abs(BO)+Abs(BT));
    AA02Z(BN*BJ-BT*BP+BI*BQ,BN*BK-BT*BQ-
         BI*BP,BS,BR,A[(R-1)+(BC-1)*N],A[(R-1)+(X-1)*N]);
    if ( Abs(BN) <= Abs(BT)+Abs(BI) ) 
     then goto _58;
    A[(R+0)+(BC-1)*N] := (-BP-BM*A[(R-1)+(BC-1)*N]+BI*A[(R-1)+(X-1)*N])/BN;
    A[(R+0)+(X-1)*N] := (-BQ-BM*A[(R-1)+(X-1)*N]-BI*A[(R-1)+(BC-1)*N])/BN;
    goto _59;
_58:
    AA02Z(-BJ-BO*A[(R-1)+(BC-1)*N],-BK-BO*A[(R-1)+(X-1)*N],BT,BI,A[(R+0)+(BC-1)*N],A[(R+0)+(X-1)*N]);
_59:
   end;
_60:
 end;
for R:=1 to N do
 begin
  if ( R >= IR1 ) and ( R <= IR2 ) 
   then goto _62;
  for S:=R to N do
   begin
_61:
    V[(R-1)+(S-1)*N] := A[(R-1)+(S-1)*N];
   end;
_62:
 end;
for Z:=IR1 to N do
 begin
  S := N+IR1-Z;
  W := Min0(S,IR2);
  for R:=IR1 to IR2 do
   begin
    BT := 0.0e0;
    for T:=IR1 to W do
     begin
_63:
      BT := BT+V[(R-1)+(T-1)*N]*A[(T-1)+(S-1)*N];
     end;
    V[(R-1)+(S-1)*N] := BT;
_64:
   end;
 end;
goto _66;
_65:
IERR := X;
_66:
if ( IERR <> 0 ) 
 then UTAE10(IERR,N,12);
end;

end.
